#include "oxlayout.h"
#include "oxmath.h"

namespace OX {
	namespace Layout {
		///////////////////////////
		// `̈
		/////
		RectRegion::RectRegion() : w(10.0f), h(10.0f), l(), t() {
			create(w, h, l, t);
		}

		RectRegion::RectRegion(float w, float h, float l, float t) : w(w), h(h), l(l), t(t) {
			create(w, h, l, t);
		}

		RectRegion::~RectRegion() {
		}

		void RectRegion::create(float w, float h, float l, float t) {
			this->w = w; this->h = h; this->l = l; this->t = t;
			vertices = Vector<Float2>();
			const Float2 v[4] = {
				Float2(l    , t + h),
				Float2(l    , t),
				Float2(l + w, t + h),
				Float2(l + w, t),
			};
			for (unsigned i = 0; i < 4; i++)
				vertices.push(v[i]);
		}

		bool RectRegion::isContain(const Float2 &pos) {
			return (pos.x >= l) && (pos.x <= l + w) && (pos.y >= t) && (pos.y <= t + h);
		}


		///////////////////////////
		// IuWFNg
		/////
		Object::Object() {
		}

		Object::~Object() {
		}

		// _̈ɂH
		bool Object::isContain(const Float2 &pos) {
			// IuWFNgԂ֕ϊ
			// J[\ʒuHUD̃[Jʒu֕ϊ
			Float2 cp(pos);
			// @ tړ
			cp -= param.trans;
			// A ts{bgړ
			cp -= region->getPivot();
			// B t]
			float rot = -Math::toRad(param.rot);
			cp = Float2(cosf(rot) * cp.x - sinf(rot) * cp.y, sinf(rot) * cp.x + cosf(rot) * cp.y);
			// C s{bgړ
			cp += region->getPivot();

			return region->isContain(cp);
		}
	}
}