#ifndef IKD_OX_BASIC_OXLIST_H
#define IKD_OX_BASIC_OXLIST_H

#include "oxsp.h"

namespace OX {
	template<class T>
	class List {
	public:
		struct ListContainer {
			T* val;
			ListContainer *pre, *next;
			ListContainer() : pre(), next(), val() {}
			ListContainer(const T& val) : val(new T(val)), pre(), next() {}
			~ListContainer() {
				delete val;
			}

			// ̎ɑoN
			void conect(ListContainer *cont) {
				next = cont;
				cont->pre = this;
			}

			// ̎ɑ}
			void insertNext(ListContainer *cont) {
				next->pre = cont;
				cont->next = next;
				conect(cont);
			}

			// ̑Oɑ}
			void insertPre(ListContainer *cont) {
				pre->next = cont;
				cont->pre = pre;
				cont->conect(this);
			}

			// 烊N؂č폜
			void erase() {
				pre->next = next;
				next->pre = pre;
				delete this;
			}
		};

	private:
		struct Body {
			ListContainer *beg, *end;
			unsigned size;
			Body() : beg(new ListContainer), end(new ListContainer), size() {
				beg->conect(end);
			}
			~Body() {
				ListContainer *delCont = beg, *tmp;
				while(delCont) {
					tmp = delCont->next;
					delete delCont;
					delCont = tmp;
				}
			}
		};

		sp<Body> body;

	public:
		//////////////////////////////
		// Ce[^
		template<class T>
		class _IteratorBase {
		protected:
			List *list;
			ListContainer *cur, *beg_ptr, *end_ptr;
			_IteratorBase() : cur(), beg_ptr(), end_ptr(), list() {}
			_IteratorBase(List<T> *list, ListContainer* first, ListContainer *beg_ptr, ListContainer *end_ptr) : list(list), cur(first), beg_ptr(beg_ptr), end_ptr(end_ptr) {}

		public:
			operator bool() {
				return cur && (cur != beg_ptr) && (cur != end_ptr);
			}

			// l擾
			T& get() {
				return *cur->val;
			}
			const T& get() const {
				return *cur->val;
			}
		};

		//////////////////////////////
		// oI[tCe[^
		template<class T>
		class _Iterator : public _IteratorBase<T> {
			bool bLoop;	// z̋

		public:
			_Iterator() : bLoop() {}
			_Iterator(List* list, ListContainer* first, ListContainer *beg_ptr, ListContainer *end_ptr) : 
				_IteratorBase(list, first, beg_ptr, end_ptr), bLoop() {}
			~_Iterator() {}

			_Iterator &operator ++(int dummy) {
				if (cur == end_ptr || cur->next == end_ptr) {
					if (bLoop)
						cur = beg_ptr->next;
					else
						cur = end_ptr;
						return *this;
				}
				cur = cur->next;
				return *this;
			}
			_Iterator &operator --(int dummy) {
				if (cur == beg_ptr || cur->pre == beg_ptr) {
					if (bLoop)
						cur = end_ptr->pre;
					else
						cur = beg_ptr;
					return *this;
				}
				cur = cur->pre;
				return *this;
			}

			// 폜
			//  폜ƎListContainerɂȂ܂
			//  Ce[gĂꍇɂ͒
			_Iterator &erase() {
				if (cur == end_ptr || cur == beg_ptr)
					return *this;
				ListContainer *next = cur->next;
				cur->erase();
				cur = next;
				list->body->size--;
				return *this;
			}

			// zH
			void setLoop(bool isLoop) {
				bLoop = isLoop;
			}
		};

		typedef _Iterator<T> Iterator;

		List() {}
		~List() {}

		// [ɒǉ
		void push_back(const T& val) {
			if (!body)
				body = sp<Body>(new Body);
			body->end->insertPre(new ListContainer(val));
			body->size++;
		}

		// O[ɒǉ
		void push_front(const T& val) {
			if (!body)
				body = sp<Body>(new Body);
			body->beg->insertNext(new ListContainer(val));
			body->size++;
		}

		// [O
		bool pop_back(T* val = 0) {
			if (!body || !body->size)
				return false;
			if (val)
				*val = *body->end->pre->val;
			body->end->pre->erase();
			body->size--;
			return true;
		}

		// O[O
		bool pop_front(T* val = 0) {
			if (!body || !body->size)
				return false;
			if (val)
				*val = *body->beg->next->val;
			body->beg->next->erase();
			body->size--;
			return true;
		}

		// 擪vfwCe[^擾
		Iterator begin() {
			if (!body)
				return Iterator(0, 0, 0, 0);
			return Iterator(this, body->beg->next, body->beg, body->end);
		}

		// Ō̗vfwCe[^擾
		Iterator end() {
			if (!body)
				return Iterator(0, 0, 0, 0);
			return Iterator(this, body->end->pre, body->beg, body->end);
		}

		// TCY擾
		unsigned size() const {
			if (!body)
				return 0;
			return body->size;
		}
	};
}

#endif
